//+------------------------------------------------------------------+
//|                                          FXG_iRSI&&Stoch_Sig.mq4 |
//|                                                                  |
//|  Ice                                                               |
//+------------------------------------------------------------------+


#property indicator_chart_window
#property indicator_buffers 6
#property indicator_color1 Lime
#property indicator_color2 Lime
#property indicator_color3 Red
#property indicator_color4 Red
#property indicator_color5 Blue
#property indicator_color6 Blue

#property indicator_width1 1
#property indicator_width2 1
#property indicator_width3 1
#property indicator_width4 1
#property indicator_width5 0
#property indicator_width6 0



double CrossUp[];
double CrossDown[];
double RSI_Stoch_UP[];
double RSI_Stoch_DN[];
double Stoch_Level_UP[];
double Stoch_Level_DN[];

extern bool show_first_signal=true;
extern bool show_second_signal=true;
extern bool show_third_signal=true;


extern int pip=25;
extern int RSIPeriod=5;
extern int stoch_k=5;
extern int stoch_d=3;
extern int stoch_slow=3;
extern int up_level=80;
extern int m_level=50;
extern int dn_level=20;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
  if(show_first_signal)
   {
      SetIndexStyle(0, DRAW_ARROW );
      SetIndexArrow(0, 233);
      SetIndexBuffer(0, CrossUp);
      SetIndexStyle(1, DRAW_ARROW);
      SetIndexArrow(1, 234);
      SetIndexBuffer(1, CrossDown);
   }
  else
   {
      SetIndexStyle(0, DRAW_NONE );
      SetIndexArrow(0, 233);
      SetIndexBuffer(0, CrossUp);
      SetIndexStyle(1, DRAW_NONE);
      SetIndexArrow(1, 234);
      SetIndexBuffer(1, CrossDown);
   } 
  if(show_second_signal) 
   {
      SetIndexStyle(2, DRAW_ARROW);
      SetIndexArrow(2, 233);
      SetIndexBuffer(2,RSI_Stoch_UP );
      SetIndexStyle(3, DRAW_ARROW);
      SetIndexArrow(3, 234);
      SetIndexBuffer(3, RSI_Stoch_DN);
   }
  else 
   {
      SetIndexStyle(2, DRAW_NONE);
      SetIndexArrow(2, 233);
      SetIndexBuffer(2,RSI_Stoch_UP );
      SetIndexStyle(3, DRAW_NONE);
      SetIndexArrow(3, 234);
      SetIndexBuffer(3, RSI_Stoch_DN);
   } 
  if( show_third_signal)
   {
      SetIndexStyle(4, DRAW_ARROW);
      SetIndexArrow(4, 233);
      SetIndexBuffer(4,Stoch_Level_UP );
      SetIndexStyle(5, DRAW_ARROW);
      SetIndexArrow(5, 234);
      SetIndexBuffer(5, Stoch_Level_DN);
   }
   else 
   {
    SetIndexStyle(4, DRAW_NONE);
   SetIndexArrow(4, 233);
   SetIndexBuffer(4,Stoch_Level_UP );
   SetIndexStyle(5, DRAW_NONE);
   SetIndexArrow(5, 234);
   SetIndexBuffer(5, Stoch_Level_DN);
   }  
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start() {
   int limit, i, counter;
   int counted_bars=IndicatorCounted();
//---- check for possible errors
   if(counted_bars<0) return(-1);
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;

   limit=Bars-counted_bars;
   
   for(i = 0; i <= limit; i++) 
    {    
        double sm,sm1,ss,ss1,r,r1;
        sm=iStochastic(NULL,0,stoch_k,stoch_d,stoch_slow,MODE_SMA,0,MODE_MAIN,i);
        sm1=iStochastic(NULL,0,stoch_k,stoch_d,stoch_slow,MODE_SMA,0,MODE_MAIN,i+1);
        ss=iStochastic(NULL,0,stoch_k,stoch_d,stoch_slow,MODE_SMA,0,MODE_SIGNAL,i);
        ss1=iStochastic(NULL,0,stoch_k,stoch_d,stoch_slow,MODE_SMA,0,MODE_SIGNAL,i+1);
        r= iRSI (NULL,0,RSIPeriod,PRICE_CLOSE,i) ;
        r1= iRSI(NULL,0,RSIPeriod,PRICE_CLOSE,i+1) ;
        
     if(sm1<ss1 && sm>ss)
      {
       CrossUp[i] = Low[i] - pip*Point;
      }
     if(sm1>ss1 && sm<ss) 
      {
       CrossDown[i] = High[i] + pip*Point;
      }
     if(sm1<r1 && sm>r)
      {
       RSI_Stoch_UP[i]=Low[i]- pip*Point;
      }   
     if(sm1>r1 && sm<r)
      {
       RSI_Stoch_DN[i]=High[i] + pip*Point;
      }         
     if((sm1<up_level && sm>up_level) ||(sm1<m_level && sm>m_level)||(sm1<dn_level && sm>dn_level))  
      {
       Stoch_Level_UP[i]=Low[i] - pip*Point;
      }  
     if((sm1>up_level && sm<up_level) ||(sm1>m_level && sm<m_level)||(sm1>dn_level && sm<dn_level))  
      {
       Stoch_Level_DN[i]=High[i] + pip*Point;
      }      
    }
   return(0);
}

